# $Id: make-release.sh 442 2012-07-29 19:54:34Z eska $
#!/bin/bash

RELEASE_VERSION="0.7"
RELEASE_DIR="/home/sebastian/download/temp/phpmygpx/"
REPO_URL="svn://svn.tuxfamily.org/svnroot/phpmygpx/phpmygpx/trunk/phpMyGPX/"
#REPO_URL="http://192.168.10.3/svn/repos/phpmygpx-tux-mirror/trunk/phpMyGPX/"

echo "Making release package of phpMyGPX..."

cd $RELEASE_DIR
echo "Checking out latest revision from SVN repository..."
svn -q --force export $REPO_URL $RELEASE_DIR
REVISION=`svn info $REPO_URL |grep '^Revision:' | sed -e 's/^Revision: //'`
echo "Export of SVN revison $REVISION done."

# Update SVN revision and release date strings in version file
DATE=`date +%Y-%m-%d`
sed -i -e "s/%DATE%/$DATE/" version.inc.php
sed -i -e "s/%REVISION%/$REVISION/" version.inc.php
sed -i -e "s/%RELEASE_VERSION%/$RELEASE_VERSION/" version.inc.php

echo "Building OpenLayers library..."
cd ./openlayers/build/
python ./build.py ../config/phpmygpx.cfg
mv ./OpenLayers.js ../
cd ../..

# Fix folder permissions
chmod 777 files/ photos/ photos/thumbs/ tiles/ tiles/mapnik/ tiles/hikebike/ upload/

# Remove some dev stuff
rm -f *.bfproject .cvsignore

cd ..
echo "Creating full tar.bz2 archive..."
tar -cjf phpMyGPX-$RELEASE_VERSION-SVN$REVISION-full.tar.bz2 phpmygpx

# Remove more dev stuff
cd phpmygpx
rm *.sh doc/*
rm -fR openlayers/build openlayers/config openlayers/lib openlayers/tools
cd ..

echo "Creating dist tar.bz2 archive..."
tar -cjf phpMyGPX-$RELEASE_VERSION-SVN$REVISION.tar.bz2 phpmygpx
echo "Done."